--- net/minecraft/src/EntityPlayer.java
+++ net/minecraft/src/EntityPlayer.java
@@ -4,6 +4,8 @@
 
 public class EntityPlayer extends EntityLiving {
 	public InventoryPlayer inventory = new InventoryPlayer(this);
+	public Container inventorySlots;
+	public Container craftingInventory;
 	public byte unusedMiningCooldown = 0;
 	public int score = 0;
 	public float prevCameraYaw;
@@ -15,6 +17,8 @@
 
 	public EntityPlayer(World var1) {
 		super(var1);
+		this.inventorySlots = new ContainerPlayer(this.inventory, !var1.multiplayerWorld);
+		this.craftingInventory = this.inventorySlots;
 		this.yOffset = 1.62F;
 		this.setLocationAndAngles((double)var1.spawnX + 0.5D, (double)(var1.spawnY + 1), (double)var1.spawnZ + 0.5D, 0.0F, 0.0F);
 		this.health = 20;
@@ -24,6 +28,25 @@
 		this.texture = "/char.png";
 	}
 
+	protected void entityInit() {
+		super.entityInit();
+		this.dataWatcher.addObject(16, Byte.valueOf((byte)0));
+	}
+	
+	public void onUpdate() {
+
+		super.onUpdate();
+		if(!this.worldObj.multiplayerWorld && this.craftingInventory != null && !this.craftingInventory.isUsableByPlayer(this)) {
+			this.closeScreen();
+			this.craftingInventory = this.inventorySlots;
+		}
+
+	}
+	
+	protected void closeScreen() {
+		this.craftingInventory = this.inventorySlots;
+	}
+
 	public void updateRidden() {
 		super.updateRidden();
 		this.prevCameraYaw = this.cameraYaw;
@@ -117,6 +140,10 @@
 	public void addToPlayerScore(Entity var1, int var2) {
 		this.score += var2;
 	}
+	
+	public void dropCurrentItem() {
+		this.dropPlayerItemWithRandomChoice(this.inventory.decrStackSize(this.inventory.currentItem, 1), false);
+	}
 
 	public void dropPlayerItem(ItemStack var1) {
 		this.dropPlayerItemWithRandomChoice(var1, false);
@@ -188,6 +215,20 @@
 
 	public void displayWorkbenchGUI() {
 	}
+	
+	public void useCurrentItemOnEntity(Entity var1) {
+		if(!var1.interact(this)) {
+			ItemStack var2 = this.getCurrentEquippedItem();
+			if(var2 != null && var1 instanceof EntityLiving) {
+				var2.useItemOnEntity((EntityLiving)var1);
+				if(var2.stackSize <= 0) {
+					var2.func_1097_a(this);
+					this.destroyCurrentEquippedItem();
+				}
+			}
+
+		}
+	}
 
 	public void onItemPickup(Entity var1, int var2) {
 	}
@@ -225,6 +266,15 @@
 			return var2 == 0 ? false : super.attackEntityFrom(var1, var2);
 		}
 	}
+	
+	protected void damageEntity(int var1) {
+		int var2 = 25 - this.inventory.getTotalArmorValue();
+		int var3 = var1 * var2 + this.damageRemainder;
+		this.inventory.damageArmor(var1);
+		var1 = var3 / 25;
+		this.damageRemainder = var3 % 25;
+		super.damageEntity(var1);
+	}
 
 	public void displayGUIFurnace(TileEntityFurnace var1) {
 	}
@@ -250,5 +300,40 @@
 	public void swingItem() {
 		this.swingProgressInt = -1;
 		this.isSwinging = true;
+	}
+	
+	public void attackTargetEntityWithCurrentItem(Entity var1) {
+		int var2 = this.inventory.getDamageVsEntity(var1);
+		if(var2 > 0) {
+			if(this.motionY < 0.0D) {
+				++var2;
+			}
+
+			var1.attackEntityFrom(this, var2);
+			ItemStack var3 = this.getCurrentEquippedItem();
+			if(var3 != null && var1 instanceof EntityLiving) {
+				var3.hitEntity((EntityLiving)var1, this);
+				if(var3.stackSize <= 0) {
+					var3.func_1097_a(this);
+					this.destroyCurrentEquippedItem();
+				}
+			}
+		}
+
+	}
+	
+	public void setEntityDead() {
+		super.setEntityDead();
+		this.inventorySlots.onCraftGuiClosed(this);
+		if(this.craftingInventory != null) {
+			this.craftingInventory.onCraftGuiClosed(this);
+		}
+
+	}
+	
+	public void respawnPlayer() {
+	}
+	
+	public void onItemStackChanged(ItemStack var1) {
 	}
 }
--- net/minecraft/src/BlockPressurePlate.java
+++ net/minecraft/src/BlockPressurePlate.java
@@ -88,7 +88,8 @@
 			var1.notifyBlocksOfNeighborChange(var2, var3, var4, this.blockID);
 			var1.notifyBlocksOfNeighborChange(var2, var3 - 1, var4, this.blockID);
 			var1.markBlocksDirty(var2, var3, var4, var2, var3, var4);
-			var1.playSoundEffect((double)var2 + 0.5D, (double)var3 + 0.1D, (double)var4 + 0.5D, "random.click", 0.3F, 0.6F);
+			if (!var1.multiplayerWorld)
+				var1.playSoundEffect((double)var2 + 0.5D, (double)var3 + 0.1D, (double)var4 + 0.5D, "random.click", 0.3F, 0.6F);
 		}
 
 		if(!var6 && var5) {
@@ -96,7 +97,8 @@
 			var1.notifyBlocksOfNeighborChange(var2, var3, var4, this.blockID);
 			var1.notifyBlocksOfNeighborChange(var2, var3 - 1, var4, this.blockID);
 			var1.markBlocksDirty(var2, var3, var4, var2, var3, var4);
-			var1.playSoundEffect((double)var2 + 0.5D, (double)var3 + 0.1D, (double)var4 + 0.5D, "random.click", 0.3F, 0.5F);
+			if (!var1.multiplayerWorld)
+				var1.playSoundEffect((double)var2 + 0.5D, (double)var3 + 0.1D, (double)var4 + 0.5D, "random.click", 0.3F, 0.5F);
 		}
 
 		if(var6) {
--- net/minecraft/src/Packet11PlayerPosition.java
+++ net/minecraft/src/Packet11PlayerPosition.java
@@ -26,12 +26,12 @@
 		super.readPacketData(var1);
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.writeDouble(this.xPosition);
 		var1.writeDouble(this.yPosition);
 		var1.writeDouble(this.stance);
 		var1.writeDouble(this.zPosition);
-		super.writePacket(var1);
+		super.writePacketData(var1);
 	}
 
 	public int getPacketSize() {
--- net/minecraft/src/Packet.java
+++ net/minecraft/src/Packet.java
@@ -2,23 +2,39 @@
 
 import java.io.DataInputStream;
 import java.io.DataOutputStream;
+import java.io.EOFException;
 import java.io.IOException;
 import java.util.HashMap;
+import java.util.HashSet;
 import java.util.Map;
+import java.util.Set;
 
 public abstract class Packet {
 	private static Map packetIdToClassMap = new HashMap();
 	private static Map packetClassToIdMap = new HashMap();
+	private static Set clientPacketIdList = new HashSet();
+	private static Set serverPacketIdList = new HashSet();
+	public final long creationTimeMillis = System.currentTimeMillis();
 	public boolean isChunkDataPacket = false;
+	private static HashMap packetStats;
+	private static int totalPacketsCount;
 
-	static void addIdClassMapping(int var0, Class var1) {
+	static void addIdClassMapping(int var0, boolean var1, boolean var2, Class var3) {
 		if(packetIdToClassMap.containsKey(Integer.valueOf(var0))) {
 			throw new IllegalArgumentException("Duplicate packet id:" + var0);
-		} else if(packetClassToIdMap.containsKey(var1)) {
-			throw new IllegalArgumentException("Duplicate packet class:" + var1);
+		} else if(packetClassToIdMap.containsKey(var3)) {
+			throw new IllegalArgumentException("Duplicate packet class:" + var3);
 		} else {
-			packetIdToClassMap.put(Integer.valueOf(var0), var1);
-			packetClassToIdMap.put(var1, Integer.valueOf(var0));
+			packetIdToClassMap.put(Integer.valueOf(var0), var3);
+			packetClassToIdMap.put(var3, Integer.valueOf(var0));
+			if(var1) {
+				clientPacketIdList.add(Integer.valueOf(var0));
+			}
+
+			if(var2) {
+				serverPacketIdList.add(Integer.valueOf(var0));
+			}
+
 		}
 	}
 
@@ -33,71 +49,151 @@
 		}
 	}
 
-	public final int getPacketId() throws IOException {
+	public final int getPacketId() {
 		return ((Integer)packetClassToIdMap.get(this.getClass())).intValue();
 	}
 
-	public static Packet readPacket(DataInputStream var0) throws IOException {
-		int var1 = var0.read();
-		if(var1 == -1) {
+	public static Packet readPacket(DataInputStream var0, boolean var1) throws IOException {
+		boolean var2 = false;
+		Packet var3 = null;
+
+		int var6;
+		try {
+			var6 = var0.read();
+			if(var6 == -1) {
+				return null;
+			}
+
+			if(var1 && !serverPacketIdList.contains(Integer.valueOf(var6)) || !var1 && !clientPacketIdList.contains(Integer.valueOf(var6))) {
+				throw new IOException("Bad packet id " + var6);
+			}
+
+			var3 = getNewPacket(var6);
+			if(var3 == null) {
+				throw new IOException("Bad packet id " + var6);
+			}
+
+			var3.readPacketData(var0);
+		} catch (EOFException var5) {
+			System.out.println("Reached end of stream");
 			return null;
-		} else {
-			Packet var2 = getNewPacket(var1);
-			if(var2 == null) {
-				throw new IOException("Bad packet id " + var1);
-			} else {
-				var2.readPacketData(var0);
-				return var2;
-			}
-		}
+		}
+
+		PacketCounter var4 = (PacketCounter)packetStats.get(Integer.valueOf(var6));
+		if(var4 == null) {
+			var4 = new PacketCounter((Empty1)null);
+			packetStats.put(Integer.valueOf(var6), var4);
+		}
+
+		var4.addPacket(var3.getPacketSize());
+		++totalPacketsCount;
+		if(totalPacketsCount % 1000 == 0) {
+		}
+
+		return var3;
 	}
 
 	public static void writePacket(Packet var0, DataOutputStream var1) throws IOException {
 		var1.write(var0.getPacketId());
-		var0.writePacket(var1);
+		var0.writePacketData(var1);
+	}
+
+	public static void writeString(String var0, DataOutputStream var1) throws IOException {
+		if(var0.length() > Short.MAX_VALUE) {
+			throw new IOException("String too big");
+		} else {
+			var1.writeShort(var0.length());
+			var1.writeChars(var0);
+		}
+	}
+
+	public static String readString(DataInputStream var0, int var1) throws IOException {
+		short var2 = var0.readShort();
+		if(var2 > var1) {
+			throw new IOException("Received string length longer than maximum allowed (" + var2 + " > " + var1 + ")");
+		} else if(var2 < 0) {
+			throw new IOException("Received string length is less than zero! Weird string!");
+		} else {
+			StringBuilder var3 = new StringBuilder();
+
+			for(int var4 = 0; var4 < var2; ++var4) {
+				var3.append(var0.readChar());
+			}
+
+			return var3.toString();
+		}
 	}
 
 	public abstract void readPacketData(DataInputStream var1) throws IOException;
 
-	public abstract void writePacket(DataOutputStream var1) throws IOException;
+	public abstract void writePacketData(DataOutputStream var1) throws IOException;
 
 	public abstract void processPacket(NetHandler var1);
 
 	public abstract int getPacketSize();
 
 	static {
-		addIdClassMapping(0, Packet0KeepAlive.class);
-		addIdClassMapping(1, Packet1Login.class);
-		addIdClassMapping(2, Packet2Handshake.class);
-		addIdClassMapping(3, Packet3Chat.class);
-		addIdClassMapping(4, Packet4UpdateTime.class);
-		addIdClassMapping(5, Packet5PlayerInventory.class);
-		addIdClassMapping(6, Packet6SpawnPosition.class);
-		addIdClassMapping(10, Packet10Flying.class);
-		addIdClassMapping(11, Packet11PlayerPosition.class);
-		addIdClassMapping(12, Packet12PlayerLook.class);
-		addIdClassMapping(13, Packet13PlayerLookMove.class);
-		addIdClassMapping(14, Packet14BlockDig.class);
-		addIdClassMapping(15, Packet15Place.class);
-		addIdClassMapping(16, Packet16BlockItemSwitch.class);
-		addIdClassMapping(17, Packet17AddToInventory.class);
-		addIdClassMapping(18, Packet18ArmAnimation.class);
-		addIdClassMapping(20, Packet20NamedEntitySpawn.class);
-		addIdClassMapping(21, Packet21PickupSpawn.class);
-		addIdClassMapping(22, Packet22Collect.class);
-		addIdClassMapping(23, Packet23VehicleSpawn.class);
-		addIdClassMapping(24, Packet24MobSpawn.class);
-		addIdClassMapping(29, Packet29DestroyEntity.class);
-		addIdClassMapping(30, Packet30Entity.class);
-		addIdClassMapping(31, Packet31RelEntityMove.class);
-		addIdClassMapping(32, Packet32EntityLook.class);
-		addIdClassMapping(33, Packet33RelEntityMoveLook.class);
-		addIdClassMapping(34, Packet34EntityTeleport.class);
-		addIdClassMapping(50, Packet50PreChunk.class);
-		addIdClassMapping(51, Packet51MapChunk.class);
-		addIdClassMapping(52, Packet52MultiBlockChange.class);
-		addIdClassMapping(53, Packet53BlockChange.class);
-		addIdClassMapping(59, Packet59ComplexEntity.class);
-		addIdClassMapping(255, Packet255KickDisconnect.class);
+		addIdClassMapping(0, true, true, Packet0KeepAlive.class);
+		addIdClassMapping(1, true, true, Packet1Login.class);
+		addIdClassMapping(2, true, true, Packet2Handshake.class);
+		addIdClassMapping(3, true, true, Packet3Chat.class);
+		addIdClassMapping(4, true, false, Packet4UpdateTime.class);
+		addIdClassMapping(5, true, false, Packet5PlayerInventory.class);
+		addIdClassMapping(6, true, false, Packet6SpawnPosition.class);
+		addIdClassMapping(7, false, true, Packet7UseEntity.class);
+		addIdClassMapping(8, true, false, Packet8UpdateHealth.class);
+		addIdClassMapping(9, true, true, Packet9Respawn.class);
+		addIdClassMapping(10, true, true, Packet10Flying.class);
+		addIdClassMapping(11, true, true, Packet11PlayerPosition.class);
+		addIdClassMapping(12, true, true, Packet12PlayerLook.class);
+		addIdClassMapping(13, true, true, Packet13PlayerLookMove.class);
+		addIdClassMapping(14, false, true, Packet14BlockDig.class);
+		addIdClassMapping(15, false, true, Packet15Place.class);
+		addIdClassMapping(16, false, true, Packet16BlockItemSwitch.class);
+		addIdClassMapping(17, true, false, Packet17Sleep.class);
+		addIdClassMapping(18, true, true, Packet18Animation.class);
+		addIdClassMapping(19, false, true, Packet19EntityAction.class);
+		addIdClassMapping(20, true, false, Packet20NamedEntitySpawn.class);
+		addIdClassMapping(21, true, false, Packet21PickupSpawn.class);
+		addIdClassMapping(22, true, false, Packet22Collect.class);
+		addIdClassMapping(23, true, false, Packet23VehicleSpawn.class);
+		addIdClassMapping(24, true, false, Packet24MobSpawn.class);
+		addIdClassMapping(25, true, false, Packet25EntityPainting.class);
+		addIdClassMapping(27, false, true, Packet27Position.class);
+		addIdClassMapping(28, true, false, Packet28EntityVelocity.class);
+		addIdClassMapping(29, true, false, Packet29DestroyEntity.class);
+		addIdClassMapping(30, true, false, Packet30Entity.class);
+		addIdClassMapping(31, true, false, Packet31RelEntityMove.class);
+		addIdClassMapping(32, true, false, Packet32EntityLook.class);
+		addIdClassMapping(33, true, false, Packet33RelEntityMoveLook.class);
+		addIdClassMapping(34, true, false, Packet34EntityTeleport.class);
+		addIdClassMapping(38, true, false, Packet38EntityStatus.class);
+		addIdClassMapping(39, true, false, Packet39AttachEntity.class);
+		addIdClassMapping(40, true, false, Packet40EntityMetadata.class);
+		addIdClassMapping(50, true, false, Packet50PreChunk.class);
+		addIdClassMapping(51, true, false, Packet51MapChunk.class);
+		addIdClassMapping(52, true, false, Packet52MultiBlockChange.class);
+		addIdClassMapping(53, true, false, Packet53BlockChange.class);
+		addIdClassMapping(54, true, false, Packet54PlayNoteBlock.class);
+		addIdClassMapping(55, true, false, Packet55BlockBreakAnimation.class);
+		addIdClassMapping(60, true, false, Packet60Explosion.class);
+		addIdClassMapping(61, true, false, Packet61DoorChange.class);
+		addIdClassMapping(62, true, false, Packet62Sound.class);
+		addIdClassMapping(63, true, false, Packet63WorldParticles.class);
+		addIdClassMapping(70, true, false, Packet70Bed.class);
+		addIdClassMapping(71, true, false, Packet71Weather.class);
+		addIdClassMapping(100, true, false, Packet100OpenWindow.class);
+		addIdClassMapping(101, true, true, Packet101CloseWindow.class);
+		addIdClassMapping(102, false, true, Packet102WindowClick.class);
+		addIdClassMapping(103, true, false, Packet103SetSlot.class);
+		addIdClassMapping(104, true, false, Packet104WindowItems.class);
+		addIdClassMapping(105, true, false, Packet105UpdateProgressbar.class);
+		addIdClassMapping(106, true, true, Packet106Transaction.class);
+		addIdClassMapping(130, true, true, Packet130UpdateSign.class);
+		addIdClassMapping(131, true, false, Packet131MapData.class);
+		addIdClassMapping(200, true, false, Packet200Statistic.class);
+		addIdClassMapping(255, true, true, Packet255KickDisconnect.class);
+		packetStats = new HashMap();
+		totalPacketsCount = 0;
 	}
 }
--- net/minecraft/src/RenderGlobal.java
+++ net/minecraft/src/RenderGlobal.java
@@ -4,13 +4,18 @@
 import java.util.ArrayList;
 import java.util.Arrays;
 import java.util.Collections;
+import java.util.HashMap;
+import java.util.Iterator;
 import java.util.List;
+import java.util.Map;
 import java.util.Random;
-import net.minecraft.client.Minecraft;
+
 import org.lwjgl.opengl.ARBOcclusionQuery;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL15;
 
+import net.minecraft.client.Minecraft;
+
 public class RenderGlobal implements IWorldAccess {
 	public List tileEntities = new ArrayList();
 	private World theWorld;
@@ -36,6 +41,7 @@
 	private int maxBlockX;
 	private int maxBlockY;
 	private int maxBlockZ;
+	private Map<Integer, BlockMiningProgress> miningProgress = new HashMap<>();
 	private int renderDistance = -1;
 	private int renderEntitiesStartupCounter = 2;
 	private int countEntitiesTotal;
@@ -55,7 +61,7 @@
 	double prevSortX = -9999.0D;
 	double prevSortY = -9999.0D;
 	double prevSortZ = -9999.0D;
-	public float damagePartialTime;
+	//public float damagePartialTime;
 	int frustumCheckOffset = 0;
 
 	public RenderGlobal(Minecraft var1, RenderEngine var2) {
@@ -553,8 +559,19 @@
 
 	}
 
-	public void updateClouds() {
+	public void updateClouds() { // tick()
 		++this.cloudTickCounter;
+		if (this.cloudTickCounter % 20 == 0) {
+			Iterator iterator = this.miningProgress.values().iterator();
+
+			while (iterator.hasNext()) {
+				BlockMiningProgress blockMiningProgress = (BlockMiningProgress)iterator.next();
+				int i = blockMiningProgress.getLastUpdateTick();
+				if (this.cloudTickCounter - i > 400) {
+					iterator.remove();
+				}
+			}
+		}
 	}
 
 	public void renderSky(float var1) {
@@ -845,80 +862,78 @@
 		return this.worldRenderersToUpdate.size() == 0;
 	}
 
-	public void drawBlockBreaking(EntityPlayer var1, MovingObjectPosition var2, int var3, ItemStack var4, float var5) {
-		Tessellator var6 = Tessellator.instance;
+	public void drawBlockBreaking(EntityPlayer camera, MovingObjectPosition hit, int i, ItemStack itemInHand, float tickDelta) {
+		Tessellator tesselator = Tessellator.instance;
 		GL11.glEnable(GL11.GL_BLEND);
 		GL11.glEnable(GL11.GL_ALPHA_TEST);
 		GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE);
 		GL11.glColor4f(1.0F, 1.0F, 1.0F, (MathHelper.sin((float)System.currentTimeMillis() / 100.0F) * 0.2F + 0.4F) * 0.5F);
-		int var8;
-		if(var3 == 0) {
-			if(this.damagePartialTime > 0.0F) {
-				GL11.glBlendFunc(GL11.GL_DST_COLOR, GL11.GL_SRC_COLOR);
-				int var7 = this.renderEngine.getTexture("/terrain.png");
-				GL11.glBindTexture(GL11.GL_TEXTURE_2D, var7);
-				GL11.glColor4f(1.0F, 1.0F, 1.0F, 0.5F);
-				GL11.glPushMatrix();
-				var8 = this.theWorld.getBlockId(var2.blockX, var2.blockY, var2.blockZ);
-				Block var9 = var8 > 0 ? Block.blocksList[var8] : null;
-				GL11.glDisable(GL11.GL_ALPHA_TEST);
-				GL11.glPolygonOffset(-3.0F, -3.0F);
-				GL11.glEnable(GL11.GL_POLYGON_OFFSET_FILL);
-				var6.startDrawingQuads();
-				double var10 = var1.lastTickPosX + (var1.posX - var1.lastTickPosX) * (double)var5;
-				double var12 = var1.lastTickPosY + (var1.posY - var1.lastTickPosY) * (double)var5;
-				double var14 = var1.lastTickPosZ + (var1.posZ - var1.lastTickPosZ) * (double)var5;
-				var6.setTranslationD(-var10, -var12, -var14);
-				var6.disableColor();
-				if(var9 == null) {
-					var9 = Block.stone;
-				}
-
-				this.globalRenderBlocks.renderBlockUsingTexture(var9, var2.blockX, var2.blockY, var2.blockZ, 240 + (int)(this.damagePartialTime * 10.0F));
-				var6.draw();
-				var6.setTranslationD(0.0D, 0.0D, 0.0D);
-				GL11.glPolygonOffset(0.0F, 0.0F);
-				GL11.glDisable(GL11.GL_POLYGON_OFFSET_FILL);
-				GL11.glEnable(GL11.GL_ALPHA_TEST);
-				GL11.glDepthMask(true);
-				GL11.glPopMatrix();
-			}
-		} else if(var4 != null) {
+		if (i != 0 && itemInHand != null) {
 			GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-			float var16 = MathHelper.sin((float)System.currentTimeMillis() / 100.0F) * 0.2F + 0.8F;
-			GL11.glColor4f(var16, var16, var16, MathHelper.sin((float)System.currentTimeMillis() / 200.0F) * 0.2F + 0.5F);
-			var8 = this.renderEngine.getTexture("/terrain.png");
-			GL11.glBindTexture(GL11.GL_TEXTURE_2D, var8);
-			int var17 = var2.blockX;
-			int var18 = var2.blockY;
-			int var11 = var2.blockZ;
-			if(var2.sideHit == 0) {
-				--var18;
-			}
-
-			if(var2.sideHit == 1) {
-				++var18;
-			}
-
-			if(var2.sideHit == 2) {
-				--var11;
-			}
-
-			if(var2.sideHit == 3) {
-				++var11;
-			}
-
-			if(var2.sideHit == 4) {
-				--var17;
-			}
-
-			if(var2.sideHit == 5) {
-				++var17;
-			}
+			float f = MathHelper.sin((float)System.currentTimeMillis() / 100.0F) * 0.2F + 0.8F;
+			GL11.glColor4f(f, f, f, MathHelper.sin((float)System.currentTimeMillis() / 200.0F) * 0.2F + 0.5F);
+			int var7 = this.renderEngine.getTexture("/terrain.png");
+			GL11.glBindTexture(GL11.GL_TEXTURE_2D, var7);
 		}
 
 		GL11.glDisable(GL11.GL_BLEND);
 		GL11.glDisable(GL11.GL_ALPHA_TEST);
+	}
+
+	public void drawBlockBreaking(EntityPlayer var1, float var5) {
+		Tessellator var6 = Tessellator.instance;
+		double var10 = var1.lastTickPosX + (var1.posX - var1.lastTickPosX) * (double)var5;
+		double var12 = var1.lastTickPosY + (var1.posY - var1.lastTickPosY) * (double)var5;
+		double var14 = var1.lastTickPosZ + (var1.posZ - var1.lastTickPosZ) * (double)var5;
+		if(!this.miningProgress.isEmpty()) {
+			GL11.glBlendFunc(GL11.GL_DST_COLOR, GL11.GL_SRC_COLOR);
+			int var7 = this.renderEngine.getTexture("/terrain.png");
+			GL11.glBindTexture(GL11.GL_TEXTURE_2D, var7);
+			GL11.glColor4f(1.0F, 1.0F, 1.0F, 0.5F);
+			GL11.glPushMatrix();
+			GL11.glDisable(GL11.GL_ALPHA_TEST);
+			GL11.glPolygonOffset(-3.0F, -3.0F);
+			GL11.glEnable(GL11.GL_POLYGON_OFFSET_FILL);
+			var6.startDrawingQuads();
+			var6.setTranslationD(-var10, -var12, -var14);
+			var6.disableColor();
+
+			Iterator<BlockMiningProgress> iterator = this.miningProgress.values().iterator();
+
+			while (iterator.hasNext()) {
+				BlockMiningProgress blockMiningProgress = iterator.next();
+				double g = blockMiningProgress.getX() - var10;
+				double h = blockMiningProgress.getY() - var12;
+				double i = blockMiningProgress.getZ() - var14;
+				if (g * g + h * h + i * i > 1024.0) {
+					iterator.remove();
+				} else {
+					int j = this.theWorld.getBlockId(blockMiningProgress.getX(), blockMiningProgress.getY(), blockMiningProgress.getZ());
+					Block block = j > 0 ? Block.blocksList[j] : null;
+					if (block == null) {
+						block = Block.stone;
+					}
+
+					this.globalRenderBlocks
+					.renderBlockUsingTexture(
+							block,
+							blockMiningProgress.getX(),
+							blockMiningProgress.getY(),
+							blockMiningProgress.getZ(),
+							240 + (int)(blockMiningProgress.getProgress())
+					);
+				}
+			}
+
+			//this.globalRenderBlocks.renderBlockUsingTexture(var9, var2.blockX, var2.blockY, var2.blockZ, 240 + (int)(progress * 10.0F));
+			var6.draw();
+			var6.setTranslationD(0.0D, 0.0D, 0.0D);
+			GL11.glPolygonOffset(0.0F, 0.0F);
+			GL11.glDisable(GL11.GL_POLYGON_OFFSET_FILL);
+			GL11.glEnable(GL11.GL_ALPHA_TEST);
+			GL11.glDepthMask(true);
+			GL11.glPopMatrix();
+		}
 	}
 
 	public void drawSelectionBox(EntityPlayer var1, MovingObjectPosition var2, int var3, ItemStack var4, float var5) {
@@ -1056,25 +1071,25 @@
 		double var16 = this.mc.thePlayer.posY - var4;
 		double var18 = this.mc.thePlayer.posZ - var6;
 		if(var14 * var14 + var16 * var16 + var18 * var18 <= 256.0D) {
-			if(var1 == "bubble") {
+			if(var1.equals("bubble")) {
 				this.mc.effectRenderer.addEffect(new EntityBubbleFX(this.theWorld, var2, var4, var6, var8, var10, var12));
-			} else if(var1 == "smoke") {
+			} else if(var1.equals("smoke")) {
 				this.mc.effectRenderer.addEffect(new EntitySmokeFX(this.theWorld, var2, var4, var6));
-			} else if(var1 == "explode") {
+			} else if(var1.equals("explode")) {
 				this.mc.effectRenderer.addEffect(new EntityExplodeFX(this.theWorld, var2, var4, var6, var8, var10, var12));
-			} else if(var1 == "flame") {
+			} else if(var1.equals("flame")) {
 				this.mc.effectRenderer.addEffect(new EntityFlameFX(this.theWorld, var2, var4, var6, var8, var10, var12));
-			} else if(var1 == "lava") {
+			} else if(var1.equals("lava")) {
 				this.mc.effectRenderer.addEffect(new EntityLavaFX(this.theWorld, var2, var4, var6));
-			} else if(var1 == "splash") {
+			} else if(var1.equals("splash")) {
 				this.mc.effectRenderer.addEffect(new EntitySplashFX(this.theWorld, var2, var4, var6, var8, var10, var12));
-			} else if(var1 == "largesmoke") {
+			} else if(var1.equals("largesmoke")) {
 				this.mc.effectRenderer.addEffect(new EntitySmokeFX(this.theWorld, var2, var4, var6, 2.5F));
-			} else if(var1 == "reddust") {
+			} else if(var1.equals("reddust")) {
 				this.mc.effectRenderer.addEffect(new EntityReddustFX(this.theWorld, var2, var4, var6));
-			} else if(var1 == "snowballpoof") {
+			} else if(var1.equals("snowballpoof")) {
 				this.mc.effectRenderer.addEffect(new EntitySlimeFX(this.theWorld, var2, var4, var6, Item.snowball));
-			} else if(var1 == "slime") {
+			} else if(var1.equals("slime")) {
 				this.mc.effectRenderer.addEffect(new EntitySlimeFX(this.theWorld, var2, var4, var6, Item.slimeBall));
 			}
 
@@ -1109,5 +1124,82 @@
 	}
 
 	public void doNothingWithTileEntity(int var1, int var2, int var3, TileEntity var4) {
+	}
+	
+	public void func_28136_a(EntityPlayer var1, int var2, int var3, int var4, int var5, int var6) {
+		Random var7 = this.theWorld.rand;
+		int var16;
+		switch(var2) {
+		case 1000:
+			this.theWorld.playSoundEffect((double)var3, (double)var4, (double)var5, "random.click", 1.0F, 1.0F);
+			break;
+		case 1001:
+			this.theWorld.playSoundEffect((double)var3, (double)var4, (double)var5, "random.click", 1.0F, 1.2F);
+			break;
+		case 1002:
+			this.theWorld.playSoundEffect((double)var3, (double)var4, (double)var5, "random.bow", 1.0F, 1.2F);
+			break;
+		case 1003:
+			if(Math.random() < 0.5D) {
+				this.theWorld.playSoundEffect((double)var3 + 0.5D, (double)var4 + 0.5D, (double)var5 + 0.5D, "random.door_open", 1.0F, this.theWorld.rand.nextFloat() * 0.1F + 0.9F);
+			} else {
+				this.theWorld.playSoundEffect((double)var3 + 0.5D, (double)var4 + 0.5D, (double)var5 + 0.5D, "random.door_close", 1.0F, this.theWorld.rand.nextFloat() * 0.1F + 0.9F);
+			}
+			break;
+		case 1004:
+			this.theWorld.playSoundEffect((double)((float)var3 + 0.5F), (double)((float)var4 + 0.5F), (double)((float)var5 + 0.5F), "random.fizz", 0.5F, 2.6F + (var7.nextFloat() - var7.nextFloat()) * 0.8F);
+			break;
+		case 1005:
+			if(Item.itemsList[var6] instanceof ItemRecord) {
+				this.theWorld.playRecord(((ItemRecord)Item.itemsList[var6]).recordName, var3, var4, var5);
+			} else {
+				this.theWorld.playRecord((String)null, var3, var4, var5);
+			}
+			break;
+		case 2000:
+			int var8 = var6 % 3 - 1;
+			int var9 = var6 / 3 % 3 - 1;
+			double var10 = (double)var3 + (double)var8 * 0.6D + 0.5D;
+			double var12 = (double)var4 + 0.5D;
+			double var14 = (double)var5 + (double)var9 * 0.6D + 0.5D;
+
+			for(var16 = 0; var16 < 10; ++var16) {
+				double var31 = var7.nextDouble() * 0.2D + 0.01D;
+				double var19 = var10 + (double)var8 * 0.01D + (var7.nextDouble() - 0.5D) * (double)var9 * 0.5D;
+				double var21 = var12 + (var7.nextDouble() - 0.5D) * 0.5D;
+				double var23 = var14 + (double)var9 * 0.01D + (var7.nextDouble() - 0.5D) * (double)var8 * 0.5D;
+				double var25 = (double)var8 * var31 + var7.nextGaussian() * 0.01D;
+				double var27 = -0.03D + var7.nextGaussian() * 0.01D;
+				double var29 = (double)var9 * var31 + var7.nextGaussian() * 0.01D;
+				this.spawnParticle("smoke", var19, var21, var23, var25, var27, var29);
+			}
+
+			return;
+		case 2001:
+			var16 = var6 & 255;
+			if(var16 > 0) {
+				Block var17 = Block.blocksList[var16];
+				this.mc.sndManager.playSound(var17.stepSound.getBreakSound(), (float)var3 + 0.5F, (float)var4 + 0.5F, (float)var5 + 0.5F, (var17.stepSound.getVolume() + 1.0F) / 2.0F, var17.stepSound.getPitch() * 0.8F);
+			}
+
+			this.mc.effectRenderer.addBlockDestroyEffects(var3, var4, var5);
+		}
+
+	}
+
+	@Override
+	public void updateBlockMiningProgress(int id, int x, int y, int z, int progress) {
+		if (progress >= 0 && progress < 10) {
+			BlockMiningProgress blockMiningProgress = (BlockMiningProgress)this.miningProgress.get(id);
+			if (blockMiningProgress == null || blockMiningProgress.getX() != x || blockMiningProgress.getY() != y || blockMiningProgress.getZ() != z) {
+				blockMiningProgress = new BlockMiningProgress(id, x, y, z);
+				this.miningProgress.put(id, blockMiningProgress);
+			}
+
+			blockMiningProgress.setProgress(progress);
+			blockMiningProgress.setLastUpdateTick(this.cloudTickCounter);
+		} else {
+			this.miningProgress.remove(id);
+		}
 	}
 }
--- net/minecraft/src/BlockWorkbench.java
+++ net/minecraft/src/BlockWorkbench.java
@@ -11,6 +11,9 @@
 	}
 
 	public boolean blockActivated(World var1, int var2, int var3, int var4, EntityPlayer var5) {
+		if (var1.multiplayerWorld)
+			return true;
+		
 		var5.displayWorkbenchGUI();
 		return true;
 	}
--- /dev/null
+++ net/minecraft/src/PacketCounter.java
@@ -1,0 +1,18 @@
+package net.minecraft.src;
+
+class PacketCounter {
+	private int totalPackets;
+	private long totalBytes;
+
+	private PacketCounter() {
+	}
+
+	public void addPacket(int var1) {
+		++this.totalPackets;
+		this.totalBytes += (long)var1;
+	}
+
+	PacketCounter(Empty1 var1) {
+		this();
+	}
+}
--- net/minecraft/src/ChunkProviderClient.java
+++ net/minecraft/src/ChunkProviderClient.java
@@ -20,7 +20,7 @@
 	}
 
 	public boolean chunkExists(int var1, int var2) {
-		ChunkCoordinates var3 = new ChunkCoordinates(var1, var2);
+		ChunkCoordIntPair var3 = new ChunkCoordIntPair(var1, var2);
 		return this.chunkMapping.containsKey(var3);
 	}
 
@@ -30,12 +30,12 @@
 			var3.onChunkUnload();
 		}
 
-		this.chunkMapping.remove(new ChunkCoordinates(var1, var2));
+		this.chunkMapping.remove(new ChunkCoordIntPair(var1, var2));
 		this.chunkListing.remove(var3);
 	}
 
 	public Chunk loadChunk(int var1, int var2) {
-		ChunkCoordinates var3 = new ChunkCoordinates(var1, var2);
+		ChunkCoordIntPair var3 = new ChunkCoordIntPair(var1, var2);
 		byte[] var4 = new byte[-Short.MIN_VALUE];
 		Chunk var5 = new Chunk(this.worldObj, var4, var1, var2);
 		Arrays.fill(var5.skylightMap.data, (byte)-1);
@@ -45,7 +45,7 @@
 	}
 
 	public Chunk provideChunk(int var1, int var2) {
-		ChunkCoordinates var3 = new ChunkCoordinates(var1, var2);
+		ChunkCoordIntPair var3 = new ChunkCoordIntPair(var1, var2);
 		Chunk var4 = (Chunk)this.chunkMapping.get(var3);
 		return var4 == null ? this.blankChunk : var4;
 	}
--- net/minecraft/src/Packet33RelEntityMoveLook.java
+++ net/minecraft/src/Packet33RelEntityMoveLook.java
@@ -18,8 +18,8 @@
 		this.pitch = var1.readByte();
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
-		super.writePacket(var1);
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		super.writePacketData(var1);
 		var1.writeByte(this.xPosition);
 		var1.writeByte(this.yPosition);
 		var1.writeByte(this.zPosition);
